#include <PID_v1.h>


#define DIRECT   0
#define REVERSE  1


int EnablePin = 8;
int duty = 0;

int PWMPin = 11;  // Timer2
int difference;
int CPR = 16;
double delT;
long last_millis = 0;
double speed_req = 2000;                             // speed (Set Point)  
double speed_act = 0;                              // speed (actual value)


volatile unsigned long ticksM1 = 0;
volatile unsigned long ticksM1_old = 0;

volatile unsigned long ticksM2 = 0;
volatile unsigned long ticksM2_old = 0;

double Input, Output, Setpoint; //180
double kp=0.3,ki=1,kd=0; //2,.5,2

PID myPID(&Input, &Output, &Setpoint,kp,ki,kd, DIRECT);


void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  
  delay(2000);
  pinMode(EnablePin, OUTPUT);     
  pinMode(PWMPin, OUTPUT);

  attachInterrupt(digitalPinToInterrupt(3), ISR_CountTicksM1, FALLING); //attachings pins to interrupts
  attachInterrupt(digitalPinToInterrupt(2), ISR_CountTicksM2, FALLING);
  analogWrite(PWMPin, duty);  
  Input = speed_act;
  Setpoint = speed_req;
  myPID.SetOutputLimits(0, 255);
  //turn the PID on
  myPID.SetMode(AUTOMATIC);  

}

void loop() {
  // put your main code here, to run repeatedly:
  digitalWrite(EnablePin, HIGH);
  //analogWrite(PWMPin, duty);

  delay(100);
/*
  if (duty >= 100) {
    duty = 255;
  } else {
    duty += 5;
  }
*/
  difference = ticksM2 - ticksM2_old;
  delT = millis() - last_millis;

  last_millis = millis();
  ticksM1_old = ticksM1;
  ticksM2_old = ticksM2;


  /*
  Serial.print("TICKS 1: ");
  Serial.println(ticksM1);
  Serial.print("TICKS 2: ");
  Serial.println(ticksM2);
  Serial.print("DIFF: ");
  Serial.println(difference);

  
  Serial.print("Delta T: ");
  Serial.println(delT);
  */
  
  speed_act = (difference*60L*1000)/(delT*CPR);
  Input = speed_act;    
  myPID.Compute();
  analogWrite(PWMPin, Output); //PWM_val);   // send PWM to motor 

  
  // Toggle enable to reset the power chips if we have had
  // an overcurrent or overtemp fault
  digitalWrite(EnablePin, LOW);  

  Serial.print("SP: ");             Serial.print(speed_req);  
  Serial.print("  RPM: ");          Serial.print(speed_act);
  Serial.print("  PWM: ");          Serial.println(Output);
  Serial.println();
}

/*
void RPM_display() {
  Serial.print("TICKS 1: ");
  Serial.println(ticksM1);
  Serial.print("TICKS 2: ");
  Serial.println(ticksM2);
  ticksM1_old = ticksM1;
  ticksM2_old = ticksM2;
}
  RPM_M1 = (ticksM1-ticksM1_old)*60;
  RPM_M2 = (ticksM2-ticksM2_old)*60;
  
  Serial.println("Ticks1: \t RPM1: \t \t Ticks2: \t RPM2:");
  Serial.print("\t");
  Serial.print(ticksM1/1000);
  Serial.print("\t \t");
  Serial.print(RPM_M1/1000);
  Serial.print("\t \t");
  Serial.print(ticksM2/1000);
  Serial.print("\t \t");
  Serial.println(RPM_M2/1000);
  ticksM1_old = ticksM1;
  ticksM2_old = ticksM2;
}
*/
void ISR_CountTicksM1() { //interrupt service routine to count the right encoder ticks
  ticksM1++;
}

void ISR_CountTicksM2() { //interrupt service routine to count the left encoder ticks
  ticksM2++;
}


